package sparqlinterpreter;

import sparqltree.SparqlSemanticTree;
import triskeloperationtree.FilterExistsNode;
import triskeloperationtree.FilterNotExistsNode;
import triskeloperationtree.FunctionNode;
import triskeloperationtree.MinusNode;
import triskeloperationtree.OptionalNode;

public class FunctionAnalizer {

    SparqlSemanticTree semanticTree;
    NodeType nodeType;
    int index;

    public FunctionAnalizer(SparqlSemanticTree semanticTree) {
        this.semanticTree = semanticTree;
    }
    
    public NodeType getNodeType(){
        return nodeType;
    }

    public int getChildsStartIndex(){
        return index;
    }

    public FunctionNode getFunction(int functionStartIndex) {
        index = functionStartIndex;
        nodeType = NodeType.binary;
        if (semanticTree.getValue(index).equals("FILTER")) {
            index++;
            return createFILTERFunction();
        }
        if (semanticTree.getValue(index).equals("MINUS")) {
            index++;
            return new MinusNode();
        }
        if (semanticTree.getValue(index).equals("OPTIONAL")) {
            index++;
            return new OptionalNode();
        }
        return null;
    }

    private FunctionNode createFILTERFunction() {
        if (semanticTree.getValue(index).equals("EXISTS")) {
            index++;
            return new FilterExistsNode();
        }
        if (semanticTree.getValue(index).equals("NOT")) {
            index= index + 2;
            return new FilterNotExistsNode();
        }
        return null;
    }
}
