package sparqlinterpreter;

import sparqltree.SparqlSemanticTree;
import triskeloperationtree.FunctionNode;
import triskeloperationtree.JoinNode;

public class FunctionHandler {

    FunctionAnalizer functionAnalizer;
    FunctionBuilder functionBuilder;

    public FunctionHandler(SparqlSemanticTree semanticTree) {
        this.functionAnalizer = new FunctionAnalizer(semanticTree);
        this.functionBuilder = new FunctionBuilder(semanticTree);
    }

    public FunctionNode getFunctionNode(int index) {
        FunctionNode result = functionAnalizer.getFunction(index);
        if (functionAnalizer.getNodeType() == NodeType.binary){
            FunctionNode joinNode = new JoinNode();
            result.addNode(joinNode);
            functionBuilder.getFunctionChilds(joinNode,functionAnalizer.getChildsStartIndex());
        }     
        return result;
    }

    public int getFunctionEndIndex() {
        return functionBuilder.getIndex();
    }
    
    
}
