package sparqlinterpreter;

import java.util.ArrayList;
import sparqltree.SparqlSemanticTree;

public class PatternAnalizer {

    int subject;
    ArrayList<Integer> predicate;
    ArrayList<Integer> object;
    SparqlSemanticTree semanticTree;
    int index;
    
    public PatternAnalizer(SparqlSemanticTree semanticTree) {
        this.semanticTree = semanticTree;
        this.predicate = new ArrayList<>();
        this.object = new ArrayList<>();
    }
    
    public int analizePattern(int patternStartIndex){
        index = patternStartIndex;
        this.subject = index++;
        clearLists();
        getPredicateAndObject();
        return index;
    }

    private int getPredicateAndObject() {
        this.predicate.add(index++);
        this.object.add(index++);
        while(this.semanticTree.getValue(index).equals(",")){
            index++;
            this.object.add(index++);
        }
        if (this.semanticTree.getValue(index).equals(";")){
              this.semanticTree.changeToken(subject, index);
        }
        return index;
    }
    
    public int getSubject(){
        return this.subject;
    }
    
    public ArrayList<Integer> getPredicateList(){
        return this.predicate;
    }
    
    public ArrayList<Integer> getObjectList(){
        return this.object;
    }

    private void clearLists() {
        if (!predicate.isEmpty()) predicate.clear();
        if (!object.isEmpty()) object.clear();
    }
}
